/*
 *      Copyright (c) 2018-2028, Chill Zhuang All rights reserved.
 *
 *  Redistribution and use in source and binary forms, with or without
 *  modification, are permitted provided that the following conditions are met:
 *
 *  Redistributions of source code must retain the above copyright notice,
 *  this list of conditions and the following disclaimer.
 *  Redistributions in binary form must reproduce the above copyright
 *  notice, this list of conditions and the following disclaimer in the
 *  documentation and/or other materials provided with the distribution.
 *  Neither the name of the dreamlu.net developer nor the names of its
 *  contributors may be used to endorse or promote products derived from
 *  this software without specific prior written permission.
 *  Author: Chill 庄骞 (smallchill@163.com)
 */
package org.security.trans.basic.controller;

import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiOperation;
import io.swagger.annotations.ApiParam;
import com.github.xiaoymin.knife4j.annotations.ApiOperationSupport;
import lombok.AllArgsConstructor;

import javax.validation.Valid;

import org.security.trans.basic.dto.EmployeeDTO;
import org.springblade.core.mp.support.Condition;
import org.springblade.core.mp.support.Query;
import org.springblade.core.tool.api.R;
import org.springblade.core.tool.utils.BeanUtil;
import org.springblade.core.tool.utils.Func;
import org.springframework.web.bind.annotation.*;
import com.baomidou.mybatisplus.core.metadata.IPage;
import org.security.ht.entity.basic.Employee;
import org.security.ht.vo.basic.EmployeeVO;
import org.security.trans.basic.service.IEmployeeService;
import org.springblade.core.boot.ctrl.BladeController;

import java.util.List;
import java.util.Objects;

/**
 * 基础信息-员工 控制器
 *
 * @author BladeX
 * @since 2022-03-07
 */
@RestController
@AllArgsConstructor
@RequestMapping("/employee")
@Api(value = "基础信息-员工", tags = "基础信息-员工接口")
public class EmployeeController extends BladeController {

	private final IEmployeeService employeeService;

	/**
	 * 详情
	 * create:qx
	 */
	@GetMapping("/{id}")
	@ApiOperationSupport(order = 1)
	@ApiOperation(value = "详情", notes = "传入id")
	public R<EmployeeVO> detail(@PathVariable String id) {
		EmployeeVO employeeVO = employeeService.getEmployeeAndFamiliesAndJobRecords(id);
		return R.data(employeeVO);
	}

	/**
	 * 自定义分页 基础信息-员工
	 * create:qx
	 */
	@GetMapping("/page")
	@ApiOperationSupport(order = 3)
	@ApiOperation(value = "分页", notes = "传入employeeDTO")
	public R<IPage<EmployeeVO>> page(EmployeeDTO employeeDTO, Query query) {
		IPage<EmployeeVO> pages = employeeService.selectEmployeePage(Condition.getPage(query), employeeDTO);
		return R.data(pages);
	}

	/**
	 * 新增 基础信息-员工
	 * create:qx
	 */
	@PostMapping("/save")
	@ApiOperationSupport(order = 4)
	@ApiOperation(value = "新增", notes = "传入employeeDTO")
	public R save(@Valid @RequestBody EmployeeDTO employeeDTO) {
		if (employeeService.saveEmployeeAndFamiliesAndJobRecords(employeeDTO)) {
			return R.status(true);
		} else {
			return R.fail("身份证号重复");
		}
	}

	/**
	 * 修改 基础信息-员工
	 * create:qx
	 */
	@PostMapping("/update")
	@ApiOperationSupport(order = 5)
	@ApiOperation(value = "修改", notes = "传入employeeDTO")
	public R update(@Valid @RequestBody EmployeeDTO employeeDTO) {
		return R.status(employeeService.updateEmployeeAndFamiliesAndJobRecords(employeeDTO));
	}

	/**
	 * 新增或修改 基础信息-员工
	 */
	@PostMapping("/submit")
	@ApiOperationSupport(order = 6)
	@ApiOperation(value = "新增或修改", notes = "传入employee")
	public R submit(@Valid @RequestBody Employee employee) {
		return R.status(employeeService.saveOrUpdate(employee));
	}


	/**
	 * 删除 基础信息-员工
	 * create:qx
	 */
	@PostMapping("/remove")
	@ApiOperationSupport(order = 8)
	@ApiOperation(value = "删除", notes = "传入ids")
	public R remove(@ApiParam(value = "主键集合", required = true) @RequestParam String ids) {
		return R.status(employeeService.removeEmployeeAndFamiliesAndJobRecords(Func.toLongList(ids)));
	}

	/**
	 * 获取安全员，负责人，分管领导等
	 * create:qx
	 */
	@GetMapping("/leader")
	@ApiOperationSupport(order = 1)
	@ApiOperation(value = "获取安全员，负责人，分管领导等", notes = "获取安全员，负责人，分管领导等")
	public R<EmployeeVO> getLeader() {
		return R.data(employeeService.getLeaderByDeptId());
	}

	@ApiOperationSupport(order = 1)
	@ApiOperation(value = "根据身份证查询员工")
	@GetMapping("/detail/{idCardNo}")
	public R<EmployeeVO> getDetail(@PathVariable String idCardNo) {
		Employee employee = employeeService.getOne(new QueryWrapper<Employee>().eq("id_card", idCardNo));
		if (Objects.isNull(employee)) {
			return R.fail("未查询到员工");
		}
		return R.data(BeanUtil.copy(employee, EmployeeVO.class));
	}
}
